IFNDEF _wininc_
include		windows.inc
ENDIF

IFNDEF KERNEL32_INC
include		kernel32.inc
includelib	kernel32.lib
ENDIF

IFNDEF USER32_INC
include		user32.inc
includelib	user32.lib
ENDIF

IFNDEF COMCTL32_INC
include		Comctl32.inc
includelib	Comctl32.lib
ENDIF

IFNDEF SHELL32_INC
include		shell32.inc
includelib	shell32.lib
ENDIF

IFNDEF OLE32_INC
include		ole32.inc
includelib	ole32.lib
ENDIF

IFNDEF PSAPI_INC
include		psapi.inc
includelib	psapi.lib
ENDIF

IFNDEF SHLWAPI_INC
include		shlwapi.inc
includelib	shlwapi.lib
ENDIF

IFNDEF COMDLG32_INC
include		comdlg32.inc
includelib	comdlg32.lib
ENDIF

IFNDEF GDI32_INC
include		gdi32.inc
includelib	gdi32.lib
ENDIF

;IFNDEF c_msvcrt
;include		msvcrt.inc
;includelib	msvcrt.lib
;ENDIF

; included with distribution
IFNDEF DBG32LIB
	includelib	Debug32.lib
ENDIF

IFNDEF ASSERT32LIB
	includelib	Assert.lib
ENDIF

includelib	dbghelp.lib
includelib	dbgeng.lib
;includelib	ntdll.lib

IFNDEF NODEBUGTOOLS
	PUBLIC RDBG_SPYENABLED
	PUBLIC RDBG_SPYHANDLER
	PUBLIC RDBG_SPYLINENUM
	PUBLIC RDBG_VEHANDLER
	PUBLIC RDBG_SPYVARADDR
	PUBLIC RDBG_SPYVARTYPE
	PUBLIC RDBG_SPYVARNAME
	PUBLIC RDBG_DbgWin
	
	PUBLIC RDBG_MONENABLED
	PUBLIC RDBG_MONVARADDR
	PUBLIC RDBG_MONVARTYPE
	PUBLIC RDBG_MONEIP
	PUBLIC RDBG_MONVARNAME
	; internal
	PUBLIC RDBG_MONOLDSTATE
	PUBLIC RDBG_MONGRDSTATE
ENDIF

QWORD_DEC = 0
QWORD_HEX = 1
DOUBLE_REAL8 = 2
FLOAT_REAL4 = 3
DWORD_DEC = 4
DWORD_HEX = 5
WORD_HEX = 6
BYTE_HEX = 7
WORD_DEC = 8
BYTE_DEC = 9

SPY_TYPE_FLOAT = 0
SPY_TYPE_DOUBLE = 1
SPY_TYPE_QWORD = 2
SPY_TYPE_DWORD = 3
SPY_TYPE_QWORDHEX = 4
SPY_TYPE_DWORDHEX = 5
SPY_TYPE_STRING = 6
SPY_TYPE_REGEAX = 7
SPY_TYPE_REGEBX = 8
SPY_TYPE_REGECX = 9
SPY_TYPE_REGEDX = 10
SPY_TYPE_REGESI = 11
SPY_TYPE_REGEDI = 12
SPY_TYPE_REGESP = 13
SPY_TYPE_REGEBP = 14

RDBGAttachForTry PROTO :DWORD
RDBGdd2hex PROTO :DWORD,:DWORD
RDBGDetachForTry PROTO
RDBGDisAssemble PROTO :DWORD,:DWORD
RDBGdq2ascii PROTO :DWORD,:DWORD
RDBGDropHandler PROTO
RDBGDumpEFlags PROTO :DWORD,:DWORD
RDBGDumpHex PROTO :DWORD,:DWORD,:DWORD
RDBGDumpStack PROTO :DWORD
RDBGEnumerateSymbols PROTO :DWORD,:DWORD,:DWORD
RDBGFormatLine PROTO :DWORD,:DWORD,:DWORD
RDBGFPUDump PROTO :DWORD
RDBGGetExceptName PROTO :DWORD
RDBGGetHandler PROTO
RDBGGetModuleByAddr PROTO :DWORD,:DWORD,:DWORD
RDBGGetSpy PROTO
RDBGGetSymbols PROTO :DWORD
RDBGMMXDump PROTO :DWORD
RDBGOC_AddRef PROTO :DWORD
RDBGOC_Output PROTO :DWORD,:DWORD,:DWORD
RDBGOC_QueryInterface PROTO :DWORD,:DWORD,:DWORD
RDBGOC_Release PROTO :DWORD
RDBGPrint2Output PROTO :DWORD
RDBGPrintError PROTO :DWORD
RDBGPrintErrorByNum PROTO :DWORD,:DWORD
RDBGPrintModuleError PROTO :DWORD,:DWORD,:DWORD
RDBGPrintNumber PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
RDBGPrintSpacer PROTO
RDBGPrintString PROTO :DWORD,:DWORD,:DWORD,:DWORD
RDBGShowHandlesThisProcess PROTO
RDBGSpy PROTO :DWORD
RDBGSymEnumSymbolsProc PROTO :DWORD,:DWORD,:DWORD
RDBGVectoredHandler PROTO :DWORD
RDBGWalkHandles PROTO :DWORD,:DWORD
RDBG_GetMonitor PROTO
RDBGFindSymbol PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

RDBG_ASRT_AllocBuffers PROTO
RDBG_ASRT_Assert PROTO :DWORD
RDBG_ASRT_DeAllocBuffers PROTO

RDBG_BRK_MessageBox PROTO :DWORD

STACKSIZE equ 60

REGISTERS STRUCT
	RegEdi DD ?
	RegEsi DD ?
	RegEbp DD ?
	RegEsp DD ?
	RegEbx DD ?
	RegEdx DD ?
	RegEcx DD ?
	RegEax DD ?
REGISTERS ENDS

STACKENTRY STRUCT
	var DD ?
	sym DD ? ; CALC_SYMBOLS
STACKENTRY ENDS

BUFFERPOINTERS STRUCT
	StackBuffer STACKENTRY STACKSIZE DUP (<?>)
	StackIndex DD ?
	reg REGISTERS <?>
	OldFS14 DD ?
	SignedOperations DD ?
BUFFERPOINTERS ends


MONITORVARS STRUCT
	PrevData DD ?
	Address DD ?
	Line DD ?
	VarType DD ?
	IP DD ?
	Enabled DD ?
	GuardState DD ?
	OldState DD ?
	UNION
		OldFilter DD ?
		hHandler DD ?
	ENDS
	szName DB 256 DUP (?)
MONITORVARS ends

DBGBRK_DLG_PARAMS STRUCT
	Exe	DB 260 DUP (?)
	File	DB 260 DUP (?)
	Line	DD ?
DBGBRK_DLG_PARAMS ends

;##################################
; From vKIm.

CTEXT macro Text
    local szText
    .data
    szText byte Text, 0
    .code
    exitm <offset szText>   
endm

FillString macro Arr, Text
    local i,j
    i = 0
    j = 0
    forc var, <&Text>
        j = ('&var' shl ((i and 3)*8)) + j
        if (i and 3) eq 3
            mov dword ptr Arr[(i and -4)], j
            j=0
        endif
        i = i + 1
    endm

    if (i and 3) eq 0
        mov byte ptr Arr[i], 0
    elseif (i and 3) eq 1
        mov word ptr Arr[i-1], j
    elseif (i and 3) eq 2
        mov word ptr Arr[i-2], j
        mov byte ptr Arr[i], 0
    elseif (i and 3) eq 3
        mov dword ptr Arr[(i-3)], j
    endif
endm

FillMem macro pString, Text
    ifdifi <&pString>, <eax>
        push eax
        mov eax, pString
        FillString [eax], <&Text>
        pop eax
    else
        FillString [eax], <&Text>
    endif
endm

;##################################

DumpSymbols macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGGetSymbols,1
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

ASSERT macro Expr
IFNDEF NODEBUGTOOLS
	assume fs:Nothing
	; Save the registers
	pushad
	; allocate memory
	invoke RDBG_ASRT_AllocBuffers
	mov edi,fs:[014h]
	mov DWORD PTR [edi+BUFFERPOINTERS.SignedOperations],TRUE
	IFNDEF SIGNEDOP
		mov DWORD PTR [edi+BUFFERPOINTERS.SignedOperations],FALSE
	ENDIF
	; mov the registers from the stack to the memory buffer (32 bytes)
	; doing it this way assures that the values are good for the assert
	mov esi,esp
	add edi,BUFFERPOINTERS.reg
	mov ecx,32
	rep movsb

	; Now call the assert function with our expression (in quotes)
	invoke RDBG_ASRT_Assert,CTEXT(Expr)
	test eax,eax
	jns @F
		push eax
		invoke RDBG_ASRT_DeAllocBuffers
		pop eax
		invoke RDBGPrintNumber,@Line,DWORD_DEC,CTEXT("ASSERT> Error in expression "),eax,0
		popad
		invoke ExitProcess,0
	@@:
	; check the result
	cmp eax,TRUE
	je @F
		invoke RDBG_ASRT_DeAllocBuffers
		invoke RDBGPrintString,@Line,CTEXT("Failed"), CTEXT("ASSERT> "), 0
		popad
		invoke ExitProcess,0
	@@:

	invoke RDBGPrintString,@Line,CTEXT("Success"), CTEXT("ASSERT> "), 0

	; Free the memory used
	invoke RDBG_ASRT_DeAllocBuffers

	; Restore the registers on exit
	popad
ENDIF
endm

DbgBreak macro
	LOCAL L1,L2,FileCurrent
IFNDEF NODEBUGTOOLS
	.data
		%FileCurrent DB "&@FileCur",0
	.code

	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
		fxsave [RDBG_XMMSAVEBUFFER]
	ENDIF
	cld

	invoke VirtualAlloc,NULL,SIZEOF DBGBRK_DLG_PARAMS,MEM_COMMIT,PAGE_READWRITE
	mov edi,eax

	; Copy the current file name
	lea eax,[edi+DBGBRK_DLG_PARAMS.File]
	invoke lstrcpy, eax, addr FileCurrent
	lea eax,[edi+DBGBRK_DLG_PARAMS.Line]
	mov DWORD PTR[eax],@Line

	invoke RDBG_BRK_MessageBox,edi
	cmp eax,5
	je L1
	cmp eax,11
	je L2

	invoke VirtualFree,edi,NULL,MEM_RELEASE
	invoke RDBGGetHandler
	invoke SetUnhandledExceptionFilter,eax
	IFDEF PRESERVEXMMREGS
		fxrstor [RDBG_XMMSAVEBUFFER]
	ENDIF
	popfd
	popad
	int 3

	L2:
	invoke VirtualFree,edi,NULL,MEM_RELEASE
	IFDEF PRESERVEXMMREGS
		fxrstor [RDBG_XMMSAVEBUFFER]
	ENDIF
	popfd
	popad
	int 3

	L1:
	invoke VirtualFree,edi,NULL,MEM_RELEASE
	IFDEF PRESERVEXMMREGS
		fxrstor [RDBG_XMMSAVEBUFFER]
	ENDIF
	popfd
	popad
ENDIF
endm

Watch macro iType:REQ, Arg:REQ
IFNDEF NODEBUGTOOLS
	assume fs:Nothing
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld

	; RDBG_GetMonitor allocates the memory necessary for this
	; function and stores the pointer in TIB.pvArbitrary
	; This method does not use the data section, avoiding
	; triggering the page guard when accessing internal data

	invoke RDBG_GetMonitor
	push eax
	mov ebx,fs:[014h]
	mov ecx,ebx

	add ecx,MONITORVARS.szName
	FillMem ecx, &Arg

	mov DWORD PTR [ebx+MONITORVARS.VarType],iType
	mov DWORD PTR [ebx+MONITORVARS.Address],offset Arg
	mov DWORD PTR [ebx+MONITORVARS.Line],@Line
	mov DWORD PTR [ebx+MONITORVARS.Enabled],1

	pop eax

	invoke SetUnhandledExceptionFilter,eax
	mov [ebx+MONITORVARS.OldFilter],eax

	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad

	int 3
ENDIF
endm

EndWatch macro
IFNDEF NODEBUGTOOLS
	assume fs:Nothing
	pushad
	pushfd
	mov ebx,fs:[014h]
	mov DWORD PTR [ebx+MONITORVARS.Line],@Line
	mov DWORD PTR [ebx+MONITORVARS.Enabled],0

	int 3

	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke SetUnhandledExceptionFilter,[ebx+MONITORVARS.OldFilter]
	invoke VirtualFree,ebx,NULL,MEM_RELEASE
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm


Spy macro iType:REQ, Var
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	ifnb <Var>
		push offset Var
		pop RDBG_SPYVARADDR
		FillMem offset RDBG_SPYVARNAME, &Var
	ELSE
		FillMem offset RDBG_SPYVARNAME, &iType
	ENDIF
	mov RDBG_SPYLINENUM,@Line
	mov RDBG_SPYVARTYPE,iType
	invoke RDBGGetSpy
	invoke SetUnhandledExceptionFilter,eax
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
	int 3
ENDIF
endm

StopSpy macro
IFNDEF NODEBUGTOOLS
	int 3
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke SetUnhandledExceptionFilter,NULL
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

Try macro Var
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	ifnb <Var>
		mov eax,Var
	else
		invoke RDBGGetHandler
	endif
	invoke SetUnhandledExceptionFilter,eax
;	invoke AddVectoredExceptionHandler,1,eax
;	mov RDBG_VEHANDLER,eax
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

EndTry macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke SetUnhandledExceptionFilter,NULL
;	invoke RemoveVectoredExceptionHandler,[RDBG_VEHANDLER]
;	mov RDBG_VEHANDLER,-1
	invoke RDBGDropHandler
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintString macro Var: REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke GlobalAlloc, GPTR, 256
    mov ebx, eax
    FillMem ebx, &Var
    mov dword ptr [eax+@SizeStr(&Var)], 203D20h
	invoke RDBGPrintString,@Line,offset Var,ebx, 0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintStringByAddr macro Var: REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke GlobalAlloc, GPTR, 256
    mov ebx, eax
    FillMem ebx, &Var
    mov dword ptr [eax+@SizeStr(&Var)], 203D20h
	invoke RDBGPrintString,@Line,Var,ebx, 0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintText macro Var: REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke GlobalAlloc, GPTR, 256
    mov ebx, eax
	invoke RDBGPrintString,@Line,CTEXT(Var),ebx, 0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DumpHandles macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGShowHandlesThisProcess
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintLine MACRO
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGPrintSpacer
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DumpFPU macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGFPUDump,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DumpMMX macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGMMXDump,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DumpMem macro start:REQ, length:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGDumpHex,start,length,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DbgDump macro start:REQ, length:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGDumpHex,start,length,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintQWORDHex macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	mov eax,offset Var
	movq mm0,[eax]
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	; Use the stack directly to do the conversion
	; and leave the parameters there for the call
	sub esp,8
	movq [esp],mm0
	push ebx
	push QWORD_HEX
	push @Line
	call RDBGPrintNumber
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintQWORD macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	movq mm0,Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	; Use the stack directly to do the conversion
	; and leave the parameters there for the call
	sub esp,8
	movq [esp],mm0
	push ebx
	push QWORD_DEC
	push @Line
	call RDBGPrintNumber
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintDWORDHex macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	invoke RDBGPrintNumber,@Line,DWORD_HEX,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintDWORD macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	invoke RDBGPrintNumber,@Line,DWORD_DEC,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintDec macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	invoke RDBGPrintNumber,@Line,DWORD_DEC,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintWORD macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	and eax,0FFFFh
	invoke RDBGPrintNumber,@Line,WORD_DEC,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintWORDHex macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	and eax,0FFFFh
	invoke RDBGPrintNumber,@Line,WORD_HEX,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintBYTE macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	and eax,0FFh
	invoke RDBGPrintNumber,@Line,BYTE_DEC,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintBYTE macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push DWORD PTR Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var
	pop eax
	and eax,0FFh
	invoke RDBGPrintNumber,@Line,BYTE_HEX,ebx,eax,0
	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintDouble macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	movq mm0,Var
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var

	; Use the stack directly to do the conversion
	; and leave the parameters there for the call
	sub esp,8
	movq [esp],mm0
	push ebx
	push DOUBLE_REAL8
	push @Line
	call RDBGPrintNumber

	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintFloat macro Var:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	push 0
	push [Var]
	invoke GlobalAlloc, GPTR, 256
	mov ebx, eax
	FillMem ebx, &Var

	push ebx
	push FLOAT_REAL4
	push @Line
	call RDBGPrintNumber

	invoke GlobalFree, ebx
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

Disassemble macro pTarget:REQ,nLines:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGDisAssemble, pTarget, nLines
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintOleError macro Arg
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGPrintErrorByNum,@Line,Arg
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintModMessage macro Arg1:REQ, Arg2:REQ
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGPrintModuleError,@Line,Arg1,Arg2
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

PrintError MACRO
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	invoke RDBGPrintError,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

DumpEFlags macro
IFNDEF NODEBUGTOOLS
	pushad
	pushfd
	IFDEF PRESERVEXMMREGS
	fxsave RDBG_XMMSAVEBUFFER
	ENDIF
	cld
	pushfd
	invoke RDBGDumpEFlags,@Line
	IFDEF PRESERVEXMMREGS
	fxrstor RDBG_XMMSAVEBUFFER
	ENDIF
	popfd
	popad
ENDIF
endm

IFNDEF DEBUGEXE
	DEBUGEXE textequ <'DbgWin.exe'>
ENDIF

.data
IFNDEF NODEBUGTOOLS
RDBG_DbgWin					DB DEBUGEXE,0

RDBG_MONENABLED DD		0
RDBG_MONVARADDR DD		0
RDBG_MONVARTYPE DD		0
RDBG_MONEIP     DD		0
RDBG_MONVARNAME DB		256 DUP (0)
; internal
RDBG_MONOLDSTATE DD		0
RDBG_MONGRDSTATE DD		0

RDBG_OLDFILTER DD 0

RDBG_CRLF DB 13,10,0

RDBG_VEHANDLER				DD -1
RDBG_SPYENABLED				DD 0
RDBG_SPYHANDLER				DD -1
RDBG_SPYLINENUM				DD 0
RDBG_SPYVARADDR				DD 0
RDBG_SPYVARTYPE				DD 0
RDBG_SPYVARNAME				DB 256 DUP (0)
ALIGN 16
RDBG_XMMSAVEBUFFER				DB 512 DUP (0)
ENDIF